//+------------------------------------------------------------------+ 
//|                                  TrendStrength jurik channel.mq4 | 
//|                                                                  | 
//|                                         http://www.forextsd.com  |
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2010, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window 
#property indicator_buffers 6 
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_color4  DarkSlateGray
#property indicator_color5  Red
#property indicator_color6  Green
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  STYLE_DASH
#property indicator_width5  1
#property indicator_width6  1

//
//
//
//
//

extern string TimeFrame                        = "Current time frame";
extern int    OmaLength                        = 21;
extern double OmaSpeed                         = 8.0;
extern bool   OmaAdaptive                      = true;
extern int    HighLowPeriod                    = 30;
extern bool   ShowChannel                      = true;
extern bool   ShowZigZag                       = true;
extern bool   alertsOn                         = true;
extern bool   alertsOnTSSlope                  = true;
extern bool   alertsOnReEnteringChannel        = true;
extern bool   alertsOnChannelSlope             = true;
extern bool   alertsOnCurrent                  = true;
extern bool   alertsMessage                    = true;
extern bool   alertsSound                      = false;
extern bool   alertsNotify                     = false;
extern bool   alertsEmail                      = false;
extern bool   arrowsVisible                    = false;
extern bool   arrowsOnTSSlope                  = true;
extern color  arrowsOnTSSlopeUpColor           = LimeGreen;
extern color  arrowsOnTSSlopeDnColor           = Red;
extern int    arrowsOnTSSlopeUpCode            = 241;
extern int    arrowsOnTSSlopeDnCode            = 242;
extern bool   arrowsOnReEnteringChannel        = true;
extern color  arrowsOnReEnteringChannelUpColor = Lime;
extern color  arrowsOnReEnteringChannelDnColor = Crimson;
extern int    arrowsOnReEnteringChannelUpCode  = 228;
extern int    arrowsOnReEnteringChannelDnCode  = 230;
extern bool   arrowsOnChannelSlope             = true;
extern color  arrowsOnChannelSlopeUpColor      = Aqua;
extern color  arrowsOnChannelSlopeDnColor      = Magenta;
extern int    arrowsOnChannelSlopeUpCode       = 225;
extern int    arrowsOnChannelSlopeDnCode       = 226;
extern string arrowsIdentifier                 = "TS arrows1";
extern double arrowsUpperGap                   = 0.5;
extern double arrowsLowerGap                   = 0.5;
extern bool   arrowsOnFirst                    = true;
extern bool   Interpolate                      = true;

//
//
//
//
//

double ts[];
double tsDa[];
double tsDb[];
double zz[];
double hb[];
double lb[];
double zzlow[];
double zzhigh[];
double slope[];
double trend1[];
double trend2[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//
//
//
//
//

int init() 
{ 
   IndicatorBuffers(11);  
     SetIndexBuffer(0, ts); SetIndexLabel(0,"TS");
     SetIndexBuffer(1, tsDa);
     SetIndexBuffer(2, tsDb); 
     SetIndexBuffer(3, zz); SetIndexLabel(3, NULL);  SetIndexStyle(3,DRAW_SECTION);       
     SetIndexBuffer(4, hb);
     SetIndexBuffer(5, lb);
     SetIndexBuffer(6, zzlow);
     SetIndexBuffer(7, zzhigh);
     SetIndexBuffer(8, slope);
     SetIndexBuffer(9, trend1);
     SetIndexBuffer(10,trend2);
     SetIndexEmptyValue(0,0);
     SetIndexEmptyValue(3,0);
     SetIndexEmptyValue(6,0);
     SetIndexEmptyValue(7,0);
   
     if (ShowChannel)
     {
       SetIndexStyle(4,DRAW_LINE);
       SetIndexStyle(5,DRAW_LINE);
     }
     else      
     {
       SetIndexStyle(4,DRAW_NONE);
       SetIndexStyle(5,DRAW_NONE);
     }
   
     //
     //
     //
     //
     //
   
       OmaLength         = MathMax(OmaLength,1);
       OmaSpeed          = MathMax(OmaSpeed,-1.5);
       indicatorFileName = WindowExpertName();
       calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
       returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
       timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" TrendStrength Oma channel"); 
return(0);
} 

//
//
//
//
//

int deinit()
{  
   deleteArrows();  
return(0); 
} 

//
//
//
//
//

int start() 
{  
   int counted_bars=IndicatorCounted();
   int lastZag;
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1); 
          if (returnBars) { ts[0] = MathMin(limit+1,Bars-1); return(0); }
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {     
       if (slope[limit]==-1) CleanPoint(limit,tsDa,tsDb);
       if (ShowZigZag) for (lastZag=limit+1; lastZag<Bars; lastZag++) if (zzlow[lastZag] != 0 || zzhigh[lastZag] != 0) break;
       for (i=limit;i>=0; i--)
       {
           double       tmp = iMA(NULL,0, 5,0,MODE_EMA, PRICE_CLOSE,i);     
           double ma1 = tmp - iMA(NULL,0,10,0,MODE_SMMA,PRICE_CLOSE,i); 
           double ma2 = tmp - iMA(NULL,0,20,0,MODE_SMMA,PRICE_CLOSE,i); 
           double ma3 = tmp - iMA(NULL,0,30,0,MODE_SMMA,PRICE_CLOSE,i); 
           double ma4 = tmp - iMA(NULL,0,40,0,MODE_SMMA,PRICE_CLOSE,i);  
           double ma5 = tmp - iMA(NULL,0,50,0,MODE_SMMA,PRICE_CLOSE,i);
           double ma6 = tmp - iMA(NULL,0,60,0,MODE_SMMA,PRICE_CLOSE,i);
           double ma7 = tmp - iMA(NULL,0,70,0,MODE_SMMA,PRICE_CLOSE,i);
           double ma8 = tmp - iMA(NULL,0,80,0,MODE_SMMA,PRICE_CLOSE,i);
           double ma9 = tmp - iMA(NULL,0,90,0,MODE_SMMA,PRICE_CLOSE,i);                
         
              ts[i] = iOma((ma1+ma2+ma3+ma4+ma5+ma6+ma7+ma8+ma9)/9,OmaLength,OmaSpeed,OmaAdaptive,0);
              lb[i] = ts[ArrayMinimum(ts,HighLowPeriod,i)];
              hb[i] = ts[ArrayMaximum(ts,HighLowPeriod,i)];
          
              //
              //
              //
              //
              //
              
              tsDa[i]   = EMPTY_VALUE;
              tsDb[i]   = EMPTY_VALUE;
              slope[i]  = slope[i+1];
              trend1[i] = trend1[i+1];
              trend2[i] = trend2[i+1];
              if (ts[i] > ts[i+1])                      slope[i]  = 1;  // ts slope up
              if (ts[i] < ts[i+1])                      slope[i]  =-1;  // ts slope down
              if (ts[i] > lb[i]  && ts[i+1] <= lb[i+1]) trend1[i] = 1;  // ts entering channel up  
              if (ts[i] < hb[i]  && ts[i+1] >= hb[i+1]) trend1[i] =-1;  // ts entering channel down
              if (hb[i] > hb[i+1]&& hb[i+1] == hb[i+2]) trend2[i] = 1;  // upper channel sloping up
              if (lb[i] < lb[i+1]&& lb[i+1] == lb[i+2]) trend2[i] =-1;  // lower channel sloping down
              if (slope[i]==-1) PlotPoint(i,tsDa,tsDb,ts); 
              
              
   //
   //
   //
   //
   //
   
   if (!ShowZigZag) continue;
      
              zzlow[i]  = 0;
              zzhigh[i] = 0;
              
              if (lb[i] < lb[i+1])
              {
                  if (zz[lastZag] == lb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  lb[i];
                      zzlow[i]    =  lb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (hb[i] > hb[i+1])
              {
                  if (zz[lastZag] == hb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  hb[i];
                      zzhigh[i]   =  hb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (zz[i] != 0)
              {
                  zz[i] = 0;
                  for (lastZag=i+1; lastZag<Bars; lastZag++)
                  {
                     if (zzlow[lastZag]  != 0) { zz[lastZag] = zzlow[lastZag];  break; }
                     if (zzhigh[lastZag] != 0) { zz[lastZag] = zzhigh[lastZag]; break; }
                  }
                  
              }
              
              //
              //
              //
              //
              //
              
              if (arrowsVisible)
              {
                ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
                ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
                ObjectDelete(arrowsIdentifier+":3:"+Time[i]);
                string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
                if (arrowsOnTSSlope && slope[i] != slope[i+1])
                {
                  if (slope[i] == 1) drawArrow("1",0.5,i,arrowsOnTSSlopeUpColor,arrowsOnTSSlopeUpCode,false);
                  if (slope[i] ==-1) drawArrow("1",0.5,i,arrowsOnTSSlopeDnColor,arrowsOnTSSlopeDnCode, true);
                } 
                if (arrowsOnReEnteringChannel && trend1[i] != trend1[i+1])
                {
                  if (trend1[i] == 1) drawArrow("2",1,i,arrowsOnReEnteringChannelUpColor,arrowsOnReEnteringChannelUpCode,false);
                  if (trend1[i] ==-1) drawArrow("2",1,i,arrowsOnReEnteringChannelDnColor,arrowsOnReEnteringChannelDnCode, true);
                }      
                if (arrowsOnChannelSlope && trend2[i] != trend2[i+1])
                {
                  if (trend2[i] == 1) drawArrow("3",1.5,i,arrowsOnChannelSlopeUpColor,arrowsOnChannelSlopeUpCode,false);
                  if (trend2[i] ==-1) drawArrow("3",1.5,i,arrowsOnChannelSlopeDnColor,arrowsOnChannelSlopeDnCode, true);
                }                                                
              }         
    
          } 
          
          //
          //
          //
          //
          //
   
          if (alertsOn)
          {
             if (alertsOnCurrent)
                 int whichBar = 0;
             else     whichBar = 1;
      
             //
             //
             //
             //
             //
      
             static datetime time1 = 0;
             static string   mess1 = "";
                if (alertsOnTSSlope && slope[whichBar] != slope[whichBar+1])
                {
                   if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar," sloping up ");
                   if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar," sloping down ");
                }            
             static datetime time2 = 0;
             static string   mess2 = "";
                if (alertsOnReEnteringChannel && trend1[whichBar] != trend1[whichBar+1])
                {
                   if (trend1[whichBar] ==  1) doAlert(time2,mess2,whichBar," reentering channel up ");
                   if (trend1[whichBar] == -1) doAlert(time2,mess2,whichBar," reentering channel down ");
                }  
             static datetime time3 = 0;
             static string   mess3 = "";
                if (alertsOnChannelSlope && trend2[whichBar] != trend2[whichBar+1])
                {
                   if (trend2[whichBar] ==  1) doAlert(time3,mess3,whichBar," upper channel sloping up ");
                   if (trend2[whichBar] == -1) doAlert(time3,mess3,whichBar," lower channel sloping down ");
                }            
       }     
    return(0); 
    }
    
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (ShowZigZag) for (lastZag=limit+1; lastZag<Bars; lastZag++) if (zzlow[lastZag] != 0 || zzhigh[lastZag] != 0) break;
    if (slope[limit]==-1) CleanPoint(limit,tsDa,tsDb);
    for (i=limit;i>=0; i--)
    {
        int y = iBarShift(NULL,timeFrame,Time[i]);
            ts[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,alertsOn,alertsOnTSSlope,alertsOnReEnteringChannel,alertsOnChannelSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,
                        arrowsVisible,arrowsOnTSSlope,arrowsOnReEnteringChannel,arrowsOnChannelSlope,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnTSSlopeUpColor,arrowsOnTSSlopeDnColor,arrowsOnTSSlopeUpCode,arrowsOnTSSlopeDnCode,
                        arrowsOnReEnteringChannelUpColor,arrowsOnReEnteringChannelDnColor,arrowsOnReEnteringChannelUpCode,arrowsOnReEnteringChannelDnCode,arrowsOnChannelSlopeUpColor,arrowsOnChannelSlopeDnColor,arrowsOnChannelSlopeUpCode,arrowsOnChannelSlopeDnCode,arrowsOnFirst,0,y);
            tsDa[i]   = EMPTY_VALUE;
            tsDb[i]   = EMPTY_VALUE;
            zz[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,alertsOn,alertsOnTSSlope,alertsOnReEnteringChannel,alertsOnChannelSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,
                        arrowsVisible,arrowsOnTSSlope,arrowsOnReEnteringChannel,arrowsOnChannelSlope,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnTSSlopeUpColor,arrowsOnTSSlopeDnColor,arrowsOnTSSlopeUpCode,arrowsOnTSSlopeDnCode,
                        arrowsOnReEnteringChannelUpColor,arrowsOnReEnteringChannelDnColor,arrowsOnReEnteringChannelUpCode,arrowsOnReEnteringChannelDnCode,arrowsOnChannelSlopeUpColor,arrowsOnChannelSlopeDnColor,arrowsOnChannelSlopeUpCode,arrowsOnChannelSlopeDnCode,arrowsOnFirst,3,y);
            hb[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,alertsOn,alertsOnTSSlope,alertsOnReEnteringChannel,alertsOnChannelSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,
                        arrowsVisible,arrowsOnTSSlope,arrowsOnReEnteringChannel,arrowsOnChannelSlope,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnTSSlopeUpColor,arrowsOnTSSlopeDnColor,arrowsOnTSSlopeUpCode,arrowsOnTSSlopeDnCode,
                        arrowsOnReEnteringChannelUpColor,arrowsOnReEnteringChannelDnColor,arrowsOnReEnteringChannelUpCode,arrowsOnReEnteringChannelDnCode,arrowsOnChannelSlopeUpColor,arrowsOnChannelSlopeDnColor,arrowsOnChannelSlopeUpCode,arrowsOnChannelSlopeDnCode,arrowsOnFirst,4,y);
            lb[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,alertsOn,alertsOnTSSlope,alertsOnReEnteringChannel,alertsOnChannelSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,
                        arrowsVisible,arrowsOnTSSlope,arrowsOnReEnteringChannel,arrowsOnChannelSlope,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnTSSlopeUpColor,arrowsOnTSSlopeDnColor,arrowsOnTSSlopeUpCode,arrowsOnTSSlopeDnCode,
                        arrowsOnReEnteringChannelUpColor,arrowsOnReEnteringChannelDnColor,arrowsOnReEnteringChannelUpCode,arrowsOnReEnteringChannelDnCode,arrowsOnChannelSlopeUpColor,arrowsOnChannelSlopeDnColor,arrowsOnChannelSlopeUpCode,arrowsOnChannelSlopeDnCode,arrowsOnFirst,5,y);
            zzlow[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,alertsOn,alertsOnTSSlope,alertsOnReEnteringChannel,alertsOnChannelSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,
                        arrowsVisible,arrowsOnTSSlope,arrowsOnReEnteringChannel,arrowsOnChannelSlope,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnTSSlopeUpColor,arrowsOnTSSlopeDnColor,arrowsOnTSSlopeUpCode,arrowsOnTSSlopeDnCode,
                        arrowsOnReEnteringChannelUpColor,arrowsOnReEnteringChannelDnColor,arrowsOnReEnteringChannelUpCode,arrowsOnReEnteringChannelDnCode,arrowsOnChannelSlopeUpColor,arrowsOnChannelSlopeDnColor,arrowsOnChannelSlopeUpCode,arrowsOnChannelSlopeDnCode,arrowsOnFirst,6,y);
            zzhigh[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,alertsOn,alertsOnTSSlope,alertsOnReEnteringChannel,alertsOnChannelSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,
                        arrowsVisible,arrowsOnTSSlope,arrowsOnReEnteringChannel,arrowsOnChannelSlope,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnTSSlopeUpColor,arrowsOnTSSlopeDnColor,arrowsOnTSSlopeUpCode,arrowsOnTSSlopeDnCode,
                        arrowsOnReEnteringChannelUpColor,arrowsOnReEnteringChannelDnColor,arrowsOnReEnteringChannelUpCode,arrowsOnReEnteringChannelDnCode,arrowsOnChannelSlopeUpColor,arrowsOnChannelSlopeDnColor,arrowsOnChannelSlopeUpCode,arrowsOnChannelSlopeDnCode,arrowsOnFirst,7,y);
            slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,alertsOn,alertsOnTSSlope,alertsOnReEnteringChannel,alertsOnChannelSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,
                        arrowsVisible,arrowsOnTSSlope,arrowsOnReEnteringChannel,arrowsOnChannelSlope,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnTSSlopeUpColor,arrowsOnTSSlopeDnColor,arrowsOnTSSlopeUpCode,arrowsOnTSSlopeDnCode,
                        arrowsOnReEnteringChannelUpColor,arrowsOnReEnteringChannelDnColor,arrowsOnReEnteringChannelUpCode,arrowsOnReEnteringChannelDnCode,arrowsOnChannelSlopeUpColor,arrowsOnChannelSlopeDnColor,arrowsOnChannelSlopeUpCode,arrowsOnChannelSlopeDnCode,arrowsOnFirst,8,y);
            
            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  ts[i+k] = ts[i] + (ts[i+n] - ts[i]) * k/n;
                  hb[i+k] = hb[i] + (hb[i+n] - hb[i]) * k/n;
                  lb[i+k] = lb[i] + (lb[i+n] - lb[i]) * k/n;
               }  	            
   }
   for (i=limit;i>=0; i--) if (slope[i]==-1) PlotPoint(i,tsDa,tsDb,ts); 
return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][7];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
   return(v03);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!arrowsOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",timeFrameToString(Period())+" TrendStrength Oma  ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TrendStrength Oma "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}